#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <string.h>
 
#define _size_mem	32
#define _master_count	0
#define _slave_count	4


int main(int argc, char *argv[]) {
        key_t key;
        int semid,shmid;
        struct sembuf sops;
        char *shmaddr, st = 0;
        //char str[256];
 
        key=12345;
 
        if ((shmid = shmget(key, _size_mem, 0666)) < 0) { perror("shmget"); return 1; }
        if ((shmaddr = (char*)shmat(shmid, NULL, 0)) == (void*)-1) { perror("shmat"); return 1; }
 
        semid = semget(key, 1, 0666);
        sops.sem_num = 0;
        sops.sem_flg = 0;
 
        do {
                // Ожидаем доступа к общей памяти
                //printf("PROC#2> Waiting access to shared buffer\n");
                sops.sem_op = -1;
                semop(semid, &sops, 1);
                //
                printf("Master Count %.4X   Slave Count %.4X\n", (u_int16_t)(*(shmaddr + _master_count)), (u_int16_t)(*(shmaddr + _slave_count)));
		if((*(shmaddr + _slave_count)) < 0xFFFF)
			(*(shmaddr + _slave_count))++;
		else
			(*(shmaddr + _slave_count)) = 0;
		// Освобождаем доступ
                sops.sem_op = 1; 
                semop(semid, &sops, 1);
                usleep(1000);
        } while (1);
        shmdt(shmaddr);
 
        return 0;
}

